package xyz.stachel.zombiesutils;

import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.client.rendering.v1.HudLayerRegistrationCallback;
import net.hypixel.modapi.HypixelModAPI;
import net.hypixel.modapi.packet.impl.clientbound.event.ClientboundLocationPacket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import xyz.stachel.zombiesutils.config.Config;
import xyz.stachel.zombiesutils.game.GameManager;
import xyz.stachel.zombiesutils.handlers.Location;
import xyz.stachel.zombiesutils.handlers.Renderer;

public class ZombiesUtils implements ModInitializer {

  private static final GameManager gameManager = new GameManager();

  public static GameManager getGameManager() {
    return gameManager;
  }

  public static final String MOD_ID = "zombies-utils";
  public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);

  @Override
  public void onInitialize() {
    HypixelModAPI.getInstance().subscribeToEventPacket(ClientboundLocationPacket.class);
    HypixelModAPI.getInstance().createHandler(ClientboundLocationPacket.class, Location::onLocation);
    ZombiesUtils.LOGGER.info("initializing...");
    HudLayerRegistrationCallback.EVENT.register(new Renderer());
    Config.readFile();
  }
}
