package xyz.stachel.zombiesutils.config;

import com.google.gson.JsonElement;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import net.minecraft.client.gui.widget.ClickableWidget;
import net.minecraft.client.gui.widget.CyclingButtonWidget;
import net.minecraft.text.Text;

import java.lang.reflect.Type;

public class DoubleConfig extends AbstractConfig<Double> {

    public DoubleConfig(String key, Double defaultValue) {
        super(key, defaultValue);
    }

    public static DoubleConfig of(String key, double defaultValue) {
        return new DoubleConfig(key, defaultValue);
    }

    @Override
    public ClickableWidget createWidget(Runnable callback) {
        return CyclingButtonWidget.<Double>builder((value) -> Text.of(getValue().toString())).initially(getValue())
                .tooltip(value -> getTooltip())
                .build(getMessage(), (button, value) -> {
                    setValue(value);
                    callback.run();
                });
    }

    public static class Serializer implements JsonSerializer<DoubleConfig> {
        @Override
        public JsonElement serialize(DoubleConfig value, Type type, JsonSerializationContext context) {
            return new JsonPrimitive(value.getValue());
        }
    }
}
