package xyz.stachel.zombiesutils.config;

import com.google.gson.JsonElement;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import net.minecraft.client.gui.widget.ClickableWidget;
import net.minecraft.client.gui.widget.CyclingButtonWidget;
import net.minecraft.text.Text;

import java.lang.reflect.Type;

public class IntConfig extends AbstractConfig<Integer> {

    public IntConfig(String key, Integer defaultValue) {
        super(key, defaultValue);
    }

    public static IntConfig of(String key, int defaultValue) {
        return new IntConfig(key, defaultValue);
    }

    @Override
    public ClickableWidget createWidget(Runnable callback) {
        return CyclingButtonWidget.<Integer>builder((value) -> Text.of(getValue().toString())).initially(getValue())
                .tooltip(value -> getTooltip())
                .build(getMessage(), (button, value) -> {
                    setValue(value);
                    callback.run();
                });
    }

    public static class Serializer implements JsonSerializer<IntConfig> {
        @Override
        public JsonElement serialize(IntConfig value, Type type, JsonSerializationContext context) {
            return new JsonPrimitive(value.getValue());
        }
    }
}
