package xyz.stachel.zombiesutils.mixin;

import net.minecraft.client.network.ClientPlayNetworkHandler;
import net.minecraft.network.packet.s2c.play.TitleS2CPacket;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import xyz.stachel.zombiesutils.ZombiesUtils;
import xyz.stachel.zombiesutils.game.GameManager;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Mixin(ClientPlayNetworkHandler.class)
public abstract class ClientPlayNetworkHandlerMixin {
  @Unique
  private static final Pattern pattern = Pattern.compile("Round (\\d{1,3})");

	@Inject(at = @At("HEAD"), method = "onTitle")
    private void zombiesUtils_onTitle(TitleS2CPacket p, CallbackInfo info) {
      final String msg = p.text().getString();
      final Matcher matcher = pattern.matcher(msg);
      if (matcher.find()) {
        int number = Integer.parseInt(matcher.group(1));
        if (number >= 1 && number <= 105) {
          ZombiesUtils.getGameManager().onRound(number);
        }
      }
    }
}
