package xyz.stachel.zombiesutils.util;

import org.jetbrains.annotations.Nullable;
import xyz.stachel.zombiesutils.game.GameMode;
import xyz.stachel.zombiesutils.handlers.Location;

import static xyz.stachel.zombiesutils.game.GameMode.Map.*;

public class Utils {

    @Nullable
    public static GameMode.Map getMap(String mode) {
        return switch (mode) {
            case "ZOMBIES_DEAD_END" -> DEAD_END;
            case "ZOMBIES_BAD_BLOOD" -> BAD_BLOOD;
            case "ZOMBIES_ALIEN_ARCADIUM" -> ALIEN_ARCADIUM;
            case "ZOMBIES_PRISON" -> PRISON;
            default -> null;
        };
    }

    public static boolean isZombies() {
        return Location.getMode().startsWith("ZOMBIES");
    }

    public static boolean isHypixel() {
        return true;
    }

}
